import { IResolvable, IResolveContext } from "./tokens/resolvable";
import { Intrinsic } from "./tokens/private/intrinsic";
declare class TFExpression extends Intrinsic implements IResolvable {
    isInnerTerraformExpression: boolean;
}
declare class Reference extends TFExpression {
    private identifier;
    constructor(identifier: string);
    resolve(): string;
}
export declare function ref(identifier: string): IResolvable;
declare class FunctionCall extends TFExpression {
    private name;
    private args;
    constructor(name: string, args: Expression[]);
    private resolveString;
    private resolveArg;
    resolve(context: IResolveContext): string;
}
export declare function call(name: string, args: Expression[]): IResolvable;
export declare type Expression = Reference | FunctionCall | string | number | boolean | IResolvable;
export {};
